Smart Object Functions

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Modules | Functions
Smart Object Functions
Evas

Functions dealing with Evas smart objects (instances). More...

## Modules
| Clipped Smart Object
| Clipped smart object is a base to construct other smart objects based on the concept of having an internal clipper that is applied to all children objects.
| Box Smart Object
| A box is a convenience smart object that packs children inside it in sequence, using a layouting function specified by the user.
| Table Smart Object.
| Convenience smart object that packs children using a tabular layout using children size hints to define their size and alignment inside their cell space.
| Grid Smart Object.
| Convenience smart object that packs children under a regular grid layout, using their virtual grid location and size to determine children's positions inside the grid object's area.

## Functions
EOAPI int | evas_canvas_smart_objects_calculate_count_get (void)
| This gets the internal counter that counts the number of smart calculations. More...
EOAPI void | evas_canvas_smart_objects_calculate (void)
| Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas. More...
void | evas::canvas::smart_objects_calculate () const
| Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas. More...
int | evas::canvas::smart_objects_calculate_count_get () const
| This gets the internal counter that counts the number of smart calculations. More...
int | evas_smart_objects_calculate_count_get (const Evas_Canvas *obj)
| This gets the internal counter that counts the number of smart calculations. More...
void | evas_smart_objects_calculate (Evas_Canvas *obj)
| Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas. More...
EOAPI void * | evas_obj_smart_data_get (void)
| Retrieve user data stored on a given smart object. More...
EOAPI Evas_Object * | evas_obj_smart_parent_get (void)
| Gets the parent smart object of a given Evas object, if it has one. More...
EOAPI Eina_Bool | evas_obj_smart_type_check (const char *type)
| Checks whether a given smart object or any of its smart object parents is of a given smart class. More...
EOAPI Eina_Bool | evas_obj_smart_type_check_ptr (const char *type)
| Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison. More...
bool | evas::object::smart_type_check (::efl::eina::string_view type_) const
| Checks whether a given smart object or any of its smart object parents is of a given smart class. More...
bool | evas::object::smart_type_check_ptr (::efl::eina::string_view type_) const
| Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison. More...
void * | evas::object::smart_data_get () const
| Retrieve user data stored on a given smart object. More...
::evas::object | evas::object::smart_parent_get () const
| Gets the parent smart object of a given Evas object, if it has one. More...
void * | evas_object_smart_data_get (const Evas_Object *obj)
| Retrieve user data stored on a given smart object. More...
Evas_Object * | evas_object_smart_parent_get (const Evas_Object *obj)
| Gets the parent smart object of a given Evas object, if it has one. More...
Eina_Bool | evas_object_smart_type_check (const Evas_Object *obj, const char *type)
| Checks whether a given smart object or any of its smart object parents is of a given smart class. More...
Eina_Bool | evas_object_smart_type_check_ptr (const Evas_Object *obj, const char *type)
| Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison. More...
EOAPI void | evas_obj_smart_need_recalculate_set (Eina_Bool value)
| Set or unset the flag signalling that a given smart object needs to get recalculated. More...
EOAPI Eina_Bool | evas_obj_smart_need_recalculate_get (void)
| Get the value of the flag signalling that a given smart object needs to get recalculated. More...
EOAPI void | evas_obj_smart_data_set (void *data)
| Store a pointer to user data for a given smart object. More...
EOAPI Evas_Smart * | evas_obj_smart_get (void)
| Get the Evas_Smart from which `obj` smart object was created. More...
EOAPI Eina_Bool | evas_obj_smart_callbacks_descriptions_set (const Evas_Smart_Cb_Description *descriptions)
| Set an smart object instance's smart callbacks descriptions. More...
EOAPI void | evas_obj_smart_callbacks_descriptions_get (const Evas_Smart_Cb_Description ***class_descriptions, unsigned int *class_count, const Evas_Smart_Cb_Description ***instance_descriptions, unsigned int *instance_count)
| Retrieve an smart object's know smart callback descriptions (both instance and class ones). More...
EOAPI void | evas_obj_smart_calculate (void)
| Call the calculate() smart function immediately on a given smart object. More...
EOAPI void | evas_obj_smart_add (void)
| Instantiates a new smart object described by `s`. More...
EOAPI void | evas_obj_smart_member_add (Evas_Object *sub_obj)
| Set an Evas object as a member of a given smart object. More...
EOAPI void | evas_obj_smart_changed (void)
| Mark smart object as changed, dirty. More...
EOAPI void | evas_obj_smart_member_del (Evas_Object *sub_obj)
| Removes a member object from a given smart object. More...
bool | evas::object_smart::callbacks_descriptions_set (const Evas_Smart_Cb_Description *descriptions_) const
| Set an smart object instance's smart callbacks descriptions. More...
void | evas::object_smart::callbacks_descriptions_get (const Evas_Smart_Cb_Description ***class_descriptions_, unsigned int *class_count_, const Evas_Smart_Cb_Description ***instance_descriptions_, unsigned int *instance_count_) const
| Retrieve an smart object's know smart callback descriptions (both instance and class ones). More...
void | evas::object_smart::calculate () const
| Call the calculate() smart function immediately on a given smart object. More...
void | evas::object_smart::add () const
| Instantiates a new smart object described by `s`. More...
void | evas::object_smart::member_add (::evas::object sub_obj_) const
| Set an Evas object as a member of a given smart object. More...
void | evas::object_smart::changed () const
| Mark smart object as changed, dirty. More...
void | evas::object_smart::member_del (::evas::object sub_obj_) const
| Removes a member object from a given smart object. More...
bool | evas::object_smart::need_recalculate_get () const
| Get the value of the flag signalling that a given smart object needs to get recalculated. More...
void | evas::object_smart::need_recalculate_set (bool value_) const
| Set or unset the flag signalling that a given smart object needs to get recalculated. More...
void | evas::object_smart::data_set (void *data_) const
| Store a pointer to user data for a given smart object. More...
Evas_Smart * | evas::object_smart::smart_get () const
| Get the Evas_Smart from which `obj` smart object was created. More...
void | evas_object_smart_need_recalculate_set (Evas_Object_Smart *obj, Eina_Bool value)
| Set or unset the flag signalling that a given smart object needs to get recalculated. More...
Eina_Bool | evas_object_smart_need_recalculate_get (const Evas_Object_Smart *obj)
| Get the value of the flag signalling that a given smart object needs to get recalculated. More...
void | evas_object_smart_data_set (Evas_Object_Smart *obj, void *data)
| Store a pointer to user data for a given smart object. More...
Evas_Smart * | evas_object_smart_smart_get (const Evas_Object_Smart *obj)
| Get the Evas_Smart from which `obj` smart object was created. More...
Eina_Bool | evas_object_smart_callbacks_descriptions_set (Evas_Object_Smart *obj, const Evas_Smart_Cb_Description *descriptions)
| Set an smart object instance's smart callbacks descriptions. More...
void | evas_object_smart_callbacks_descriptions_get (const Evas_Object_Smart *obj, const Evas_Smart_Cb_Description ***class_descriptions, unsigned int *class_count, const Evas_Smart_Cb_Description ***instance_descriptions, unsigned int *instance_count)
| Retrieve an smart object's know smart callback descriptions (both instance and class ones). More...
void | evas_object_smart_calculate (Evas_Object_Smart *obj)
| Call the calculate() smart function immediately on a given smart object. More...
void | evas_object_smart_changed (Evas_Object_Smart *obj)
| Mark smart object as changed, dirty. More...
void | evas_smart_legacy_type_register (const char *type, const Eo_Class *klass)
| Registers an object type and its associated class. More...
Evas_Object * | evas_object_smart_add (Evas *e, Evas_Smart *s)
| Instantiates a new smart object described by `s`. More...
void | evas_object_smart_member_add (Evas_Object *obj, Evas_Object *smart_obj)
| Set an Evas object as a member of a given smart object. More...
void | evas_object_smart_member_del (Evas_Object *obj)
| Removes a member object from a given smart object. More...
void | evas_object_smart_callback_add (Evas_Object *obj, const char *event, Evas_Smart_Cb func, const void *data)
| Add (register) a callback function to the smart event specified by `event` on the smart object `obj`. More...
void | evas_object_smart_callback_priority_add (Evas_Object *obj, const char *event, Evas_Callback_Priority priority, Evas_Smart_Cb func, const void *data)
| Add (register) a callback function to the smart event specified by `event` on the smart object `obj`. More...
void * | evas_object_smart_callback_del (Evas_Object *obj, const char *event, Evas_Smart_Cb func)
| Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`. More...
void * | evas_object_smart_callback_del_full (Evas_Object *obj, const char *event, Evas_Smart_Cb func, const void *data)
| Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`. More...
void | evas_object_smart_callback_call (Evas_Object *obj, const char *event, void *event_info)
| Call a given smart callback on the smart object `obj`. More...
const void * | evas_object_smart_interface_get (const Evas_Object *obj, const char *name)
| Retrieve an Evas smart object's interface, by name string pointer. More...
void * | evas_object_smart_interface_data_get (const Evas_Object *obj, const Evas_Smart_Interface *iface)
| Retrieve an Evas smart object interface's private data. More...

## Detailed Description

Functions dealing with Evas smart objects (instances).

Smart objects are groupings of primitive Evas objects that behave as a cohesive group. For instance, a file manager icon may be a smart object composed of an image object, a text label and two rectangles that appear behind the image and text when the icon is selected. As a smart object, the normal Evas object API could be used on the icon object.

Besides that, generally smart objects implement a specific API, so that users interact with its own custom features. The API takes form of explicit exported functions one may call and smart callbacks.

# Smart events and callbacks

Smart objects can elect events (smart events, from now on) occurring inside of them to be reported back to their users via callback functions (smart callbacks). This way, you can extend Evas' own object events. They are defined by an event string, which identifies them uniquely. There's also a function prototype definition for the callback functions: Evas_Smart_Cb.

When defining an Evas_Smart_Class, smart object implementors are strongly encouraged to properly set the Evas_Smart_Class::callbacks callbacks description array, so that the users of the smart object can have introspection on its events API at run time.

See some examples of this group of functions.

See also
  Smart Functions for class definitions.

## Function Documentation

EOAPI int evas_canvas_smart_objects_calculate_count_get | ( | void |  | ) |

This gets the internal counter that counts the number of smart calculations.

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This is the smart object calculate counter that this function returns the value of. It starts at the value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Since
  1.1

Referenced by evas_smart_objects_calculate_count_get().

EOAPI void evas_canvas_smart_objects_calculate | ( | void |  | ) |

Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas.

See also
  evas_object_smart_need_recalculate_set()

Referenced by evas_smart_objects_calculate().

void evas::canvas::smart_objects_calculate | ( |  | ) | const

Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas.

See also
  evas_object_smart_need_recalculate_set()

int evas::canvas::smart_objects_calculate_count_get | ( |  | ) | const

This gets the internal counter that counts the number of smart calculations.

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This is the smart object calculate counter that this function returns the value of. It starts at the value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Since
  1.1

int evas_smart_objects_calculate_count_get | ( | const Evas_Canvas * | obj | ) |

This gets the internal counter that counts the number of smart calculations.

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This is the smart object calculate counter that this function returns the value of. It starts at the value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Since
  1.1

Parameters

  e | The canvas to get the calculate counter from

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This is the smart object calculate counter that this function returns the value of. It starts at the value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Since
  1.1

References evas_canvas_smart_objects_calculate_count_get().

void evas_smart_objects_calculate | ( | Evas_Canvas * | obj | ) |

Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas.

See also
  evas_object_smart_need_recalculate_set()

References evas_canvas_smart_objects_calculate().

EOAPI void* evas_obj_smart_data_get | ( | void |  | ) |

Retrieve user data stored on a given smart object.

Returns
  A pointer to data stored using evas_object_smart_data_set(), or `NULL`, if none has been set.

See also
  evas_object_smart_data_set()

Referenced by evas_object_smart_data_get().

EOAPI Evas_Object* evas_obj_smart_parent_get | ( | void |  | ) |

Gets the parent smart object of a given Evas object, if it has one.

Returns
  Returns the parent smart object of obj or `NULL`, if obj is not a smart member of any

Referenced by evas_object_smart_parent_get().

EOAPI Eina_Bool evas_obj_smart_type_check | ( | const char * | type | ) |

Checks whether a given smart object or any of its smart object parents is of a given smart class.

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

If `obj` is not a smart object, this call will fail immediately.

This function supports Eo and legacy inheritance mechanisms. However, it is recommended to use eo_isa instead if your object is using Eo from top to bottom.

The checks use smart classes names and string comparison. There is a version of this same check using pointer comparison, since a smart class' name is a single string in Evas.

See also
  evas_object_smart_type_check_ptr()
  eo_isa

Parameters

  [in] | type | The name (type) of the smart class to check for

Referenced by evas_object_smart_type_check().

EOAPI Eina_Bool evas_obj_smart_type_check_ptr | ( | const char * | type | ) |

Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison.

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

See also
  evas_object_smart_type_check() for more details
  eo_isa

Parameters

  [in] | type | The type (name string) to check for. Must be the name

Referenced by evas_object_smart_type_check_ptr().

bool evas::object::smart_type_check | ( | ::efl::eina::string_view | type_ | ) | const

Checks whether a given smart object or any of its smart object parents is of a given smart class.

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

If `obj` is not a smart object, this call will fail immediately.

This function supports Eo and legacy inheritance mechanisms. However, it is recommended to use eo_isa instead if your object is using Eo from top to bottom.

The checks use smart classes names and string comparison. There is a version of this same check using pointer comparison, since a smart class' name is a single string in Evas.

See also
  evas_object_smart_type_check_ptr()
  eo_isa

Parameters

  type | The name (type) of the smart class to check for

bool evas::object::smart_type_check_ptr | ( | ::efl::eina::string_view | type_ | ) | const

Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison.

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

See also
  evas_object_smart_type_check() for more details
  eo_isa

Parameters

  type | The type (name string) to check for. Must be the name

void* evas::object::smart_data_get | ( |  | ) | const

Retrieve user data stored on a given smart object.

Returns
  A pointer to data stored using evas_object_smart_data_set(), or `NULL`, if none has been set.

See also
  evas_object_smart_data_set()

::evas::object evas::object::smart_parent_get | ( |  | ) | const

Gets the parent smart object of a given Evas object, if it has one.

Returns
  Returns the parent smart object of obj or `NULL`, if obj is not a smart member of any

void* evas_object_smart_data_get | ( | const Evas_Object * | obj | ) |

Retrieve user data stored on a given smart object.

Returns
  A pointer to data stored using evas_object_smart_data_set(), or `NULL`, if none has been set.

See also
  evas_object_smart_data_set()

References evas_obj_smart_data_get().

Referenced by emotion_object_image_get().

Evas_Object* evas_object_smart_parent_get | ( | const Evas_Object * | obj | ) |

Gets the parent smart object of a given Evas object, if it has one.

Returns
  Returns the parent smart object of obj or `NULL`, if obj is not a smart member of any

References evas_obj_smart_parent_get().

Eina_Bool evas_object_smart_type_check | ( | const Evas_Object * | obj,
|  | const char * | type
| ) |  |

Checks whether a given smart object or any of its smart object parents is of a given smart class.

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

If `obj` is not a smart object, this call will fail immediately.

This function supports Eo and legacy inheritance mechanisms. However, it is recommended to use eo_isa instead if your object is using Eo from top to bottom.

The checks use smart classes names and string comparison. There is a version of this same check using pointer comparison, since a smart class' name is a single string in Evas.

See also
  evas_object_smart_type_check_ptr()
  eo_isa

Parameters

  [in] | type | The name (type) of the smart class to check for

References evas_obj_smart_type_check().

Eina_Bool evas_object_smart_type_check_ptr | ( | const Evas_Object * | obj,
|  | const char * | type
| ) |  |

Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison.

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

See also
  evas_object_smart_type_check() for more details
  eo_isa

Parameters

  [in] | type | The type (name string) to check for. Must be the name

References evas_obj_smart_type_check_ptr().

EOAPI void evas_obj_smart_need_recalculate_set | ( | Eina_Bool | value | ) |

Set or unset the flag signalling that a given smart object needs to get recalculated.

If this flag is set, then the `calculate()` smart function of `obj` will be called, if one is provided, during rendering phase of Evas (see evas_render()), after which this flag will be automatically unset.

If that smart function is not provided for the given object, this flag will be left unchanged.

Note
  just setting this flag will not make the canvas' whole scene dirty, by itself, and evas_render() will have no effect. To force that, use evas_object_smart_changed(), that will also call this function automatically, with `EINA_TRUE` as parameter.

See also
  evas_object_smart_need_recalculate_get()
  evas_object_smart_calculate()
  evas_smart_objects_calculate()

Parameters

  [in] | value | whether one wants to set (`EINA_TRUE`) or to unset (`EINA_FALSE`) the flag.

Referenced by evas_object_smart_need_recalculate_set().

EOAPI Eina_Bool evas_obj_smart_need_recalculate_get | ( | void |  | ) |

Get the value of the flag signalling that a given smart object needs to get recalculated.

Returns
  if flag is set or not.

Note
  this flag will be unset during the rendering phase, when the `calculate()` smart function is called, if one is provided. If it's not provided, then the flag will be left unchanged after the rendering phase.

See also
  evas_object_smart_need_recalculate_set(), for more details

Referenced by evas_object_smart_need_recalculate_get().

EOAPI void evas_obj_smart_data_set | ( | void * | data | ) |

Store a pointer to user data for a given smart object.

This data is stored independently of the one set by evas_object_data_set(), naturally.

See also
  evas_object_smart_data_get()

Parameters

  [in] | data | A pointer to user data

Referenced by evas_object_smart_data_set().

EOAPI Evas_Smart* evas_obj_smart_get | ( | void |  | ) |

Get the Evas_Smart from which `obj` smart object was created.

Returns
  the Evas_Smart handle or `NULL`, on errors

Referenced by evas_object_smart_smart_get().

EOAPI Eina_Bool evas_obj_smart_callbacks_descriptions_set | ( | const Evas_Smart_Cb_Description * | descriptions | ) |

Set an smart object instance's smart callbacks descriptions.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on failure.

These descriptions are hints to be used by introspection and are not enforced in any way.

It will not be checked if instance callbacks descriptions have the same name as respective possibly registered in the smart object class. Both are kept in different arrays and users of evas_object_smart_callbacks_descriptions_get() should handle this case as they wish.

Note
  Becase `descriptions` must be `NULL` terminated, and because a `NULL` name makes little sense, too, Evas_Smart_Cb_Description.name must not be `NULL`.
  While instance callbacks descriptions are possible, they are not recommended. Use class callbacks descriptions instead as they make you smart object user's life simpler and will use less memory, as descriptions and arrays will be shared among all instances.

Parameters

  [in] | descriptions | `NULL` terminated array with Evas_Smart_Cb_Description descriptions. Array elements won't be modified at run time, but references to them and their contents will be made, so this array should be kept alive during the whole object's lifetime.

Referenced by evas_object_smart_callbacks_descriptions_set().

EOAPI void evas_obj_smart_callbacks_descriptions_get | ( | const Evas_Smart_Cb_Description *** | class_descriptions,
|  | unsigned int * | class_count,
|  | const Evas_Smart_Cb_Description *** | instance_descriptions,
|  | unsigned int * | instance_count
| ) |  |

Retrieve an smart object's know smart callback descriptions (both instance and class ones).

This call searches for registered callback descriptions for both instance and class of the given smart object. These arrays will be sorted by Evas_Smart_Cb_Description.name and also `NULL` terminated, so both class_count and instance_count can be ignored, if the caller wishes so. The terminator `NULL` is not counted in these values.

Note
  If just class descriptions are of interest, try evas_smart_callbacks_descriptions_get() instead.
  Use `NULL` pointers on the descriptions/counters you're not interested in: they'll be ignored by the function.

See also
  evas_smart_callbacks_descriptions_get()

Parameters

  [out] | class_descriptions | Where to store class callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned
  [out] | class_count | Returns how many class callbacks descriptions are known.
  [out] | instance_descriptions | Where to store instance callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned.
  [out] | instance_count | Returns how many instance callbacks descriptions are known.

Referenced by evas_object_smart_callbacks_descriptions_get().

EOAPI void evas_obj_smart_calculate | ( | void |  | ) |

Call the calculate() smart function immediately on a given smart object.

This will force immediate calculations (see Evas_Smart_Class) needed for renderization of this object and, besides, unset the flag on it telling it needs recalculation for the next rendering phase.

See also
  evas_object_smart_need_recalculate_set()

Referenced by evas_object_smart_calculate().

EOAPI void evas_obj_smart_add | ( | void |  | ) |

Instantiates a new smart object described by `s`.

Returns
  a new Evas_Object handle

This is the function one should use when defining the public function adding an instance of the new smart object to a given canvas. It will take care of setting all of its internals to work as they should, if the user set things properly, as seem on the EVAS_SMART_SUBCLASS_NEW, for example.

EOAPI void evas_obj_smart_member_add | ( | Evas_Object * | sub_obj | ) |

Set an Evas object as a member of a given smart object.

Members will automatically be stacked and layered together with the smart object. The various stacking functions will operate on members relative to the other members instead of the entire canvas, since they now live on an exclusive layer (see evas_object_stack_above(), for more details).

Any `smart_obj` object's specific implementation of the `member_add()` smart function will take place too, naturally.

See also
  evas_object_smart_member_del()
  evas_object_smart_members_get()

Parameters

  [in] | sub_obj | The member object

Referenced by evas_object_smart_member_add().

EOAPI void evas_obj_smart_changed | ( | void |  | ) |

Mark smart object as changed, dirty.

This will flag the given object as needing recalculation, forcefully. As an effect, on the next rendering cycle its calculate() (see Evas_Smart_Class) smart function will be called.

See also
  evas_object_smart_need_recalculate_set().
  evas_object_smart_calculate().

Referenced by evas_object_smart_changed().

EOAPI void evas_obj_smart_member_del | ( | Evas_Object * | sub_obj | ) |

Removes a member object from a given smart object.

This removes a member object from a smart object, if it was added to any. The object will still be on the canvas, but no longer associated with whichever smart object it was associated with.

See also
  evas_object_smart_member_add() for more details
  evas_object_smart_members_get()

Parameters

  [in] | sub_obj | the member object

Referenced by evas_object_smart_member_del().

bool evas::object_smart::callbacks_descriptions_set | ( | const Evas_Smart_Cb_Description * | descriptions_ | ) | const

Set an smart object instance's smart callbacks descriptions.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on failure.

These descriptions are hints to be used by introspection and are not enforced in any way.

It will not be checked if instance callbacks descriptions have the same name as respective possibly registered in the smart object class. Both are kept in different arrays and users of evas_object_smart_callbacks_descriptions_get() should handle this case as they wish.

Note
  Becase `descriptions` must be `NULL` terminated, and because a `NULL` name makes little sense, too, Evas_Smart_Cb_Description.name must not be `NULL`.
  While instance callbacks descriptions are possible, they are not recommended. Use class callbacks descriptions instead as they make you smart object user's life simpler and will use less memory, as descriptions and arrays will be shared among all instances.

Parameters

  descriptions | `NULL` terminated array with Evas_Smart_Cb_Description descriptions. Array elements won't be modified at run time, but references to them and their contents will be made, so this array should be kept alive during the whole object's lifetime.

void evas::object_smart::callbacks_descriptions_get | ( | const Evas_Smart_Cb_Description *** | class_descriptions_,
|  | unsigned int * | class_count_,
|  | const Evas_Smart_Cb_Description *** | instance_descriptions_,
|  | unsigned int * | instance_count_
| ) |  | const

Retrieve an smart object's know smart callback descriptions (both instance and class ones).

This call searches for registered callback descriptions for both instance and class of the given smart object. These arrays will be sorted by Evas_Smart_Cb_Description.name and also `NULL` terminated, so both class_count and instance_count can be ignored, if the caller wishes so. The terminator `NULL` is not counted in these values.

Note
  If just class descriptions are of interest, try evas_smart_callbacks_descriptions_get() instead.
  Use `NULL` pointers on the descriptions/counters you're not interested in: they'll be ignored by the function.

See also
  evas_smart_callbacks_descriptions_get()

Parameters

  [out] | class_descriptions | Where to store class callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned
  [out] | class_count | Returns how many class callbacks descriptions are known.
  [out] | instance_descriptions | Where to store instance callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned.
  [out] | instance_count | Returns how many instance callbacks descriptions are known.

void evas::object_smart::calculate | ( |  | ) | const

Call the calculate() smart function immediately on a given smart object.

This will force immediate calculations (see Evas_Smart_Class) needed for renderization of this object and, besides, unset the flag on it telling it needs recalculation for the next rendering phase.

See also
  evas_object_smart_need_recalculate_set()

void evas::object_smart::add | ( |  | ) | const

Instantiates a new smart object described by `s`.

Returns
  a new Evas_Object handle

This is the function one should use when defining the public function adding an instance of the new smart object to a given canvas. It will take care of setting all of its internals to work as they should, if the user set things properly, as seem on the EVAS_SMART_SUBCLASS_NEW, for example.

void evas::object_smart::member_add | ( | ::evas::object | sub_obj_ | ) | const

Set an Evas object as a member of a given smart object.

Members will automatically be stacked and layered together with the smart object. The various stacking functions will operate on members relative to the other members instead of the entire canvas, since they now live on an exclusive layer (see evas_object_stack_above(), for more details).

Any `smart_obj` object's specific implementation of the `member_add()` smart function will take place too, naturally.

See also
  evas_object_smart_member_del()
  evas_object_smart_members_get()

Parameters

  sub_obj | The member object

void evas::object_smart::changed | ( |  | ) | const

Mark smart object as changed, dirty.

This will flag the given object as needing recalculation, forcefully. As an effect, on the next rendering cycle its calculate() (see Evas_Smart_Class) smart function will be called.

See also
  evas_object_smart_need_recalculate_set().
  evas_object_smart_calculate().

void evas::object_smart::member_del | ( | ::evas::object | sub_obj_ | ) | const

Removes a member object from a given smart object.

This removes a member object from a smart object, if it was added to any. The object will still be on the canvas, but no longer associated with whichever smart object it was associated with.

See also
  evas_object_smart_member_add() for more details
  evas_object_smart_members_get()

Parameters

  sub_obj | the member object

bool evas::object_smart::need_recalculate_get | ( |  | ) | const

Get the value of the flag signalling that a given smart object needs to get recalculated.

Returns
  if flag is set or not.

Note
  this flag will be unset during the rendering phase, when the `calculate()` smart function is called, if one is provided. If it's not provided, then the flag will be left unchanged after the rendering phase.

See also
  evas_object_smart_need_recalculate_set(), for more details

Parameters

  value | whether one wants to set (`EINA_TRUE`) or to unset (`EINA_FALSE`) the flag.

void evas::object_smart::need_recalculate_set | ( | bool | value_ | ) | const

Set or unset the flag signalling that a given smart object needs to get recalculated.

If this flag is set, then the `calculate()` smart function of `obj` will be called, if one is provided, during rendering phase of Evas (see evas_render()), after which this flag will be automatically unset.

If that smart function is not provided for the given object, this flag will be left unchanged.

Note
  just setting this flag will not make the canvas' whole scene dirty, by itself, and evas_render() will have no effect. To force that, use evas_object_smart_changed(), that will also call this function automatically, with `EINA_TRUE` as parameter.

See also
  evas_object_smart_need_recalculate_get()
  evas_object_smart_calculate()
  evas_smart_objects_calculate()

Parameters

  value | whether one wants to set (`EINA_TRUE`) or to unset (`EINA_FALSE`) the flag.

void evas::object_smart::data_set | ( | void * | data_ | ) | const

Store a pointer to user data for a given smart object.

This data is stored independently of the one set by evas_object_data_set(), naturally.

See also
  evas_object_smart_data_get()

Parameters

  data | A pointer to user data

Evas_Smart* evas::object_smart::smart_get | ( |  | ) | const

Get the Evas_Smart from which `obj` smart object was created.

Returns
  the Evas_Smart handle or `NULL`, on errors

void evas_object_smart_need_recalculate_set | ( | Evas_Object_Smart * | obj,
|  | Eina_Bool | value
| ) |  |

Set or unset the flag signalling that a given smart object needs to get recalculated.

If this flag is set, then the `calculate()` smart function of `obj` will be called, if one is provided, during rendering phase of Evas (see evas_render()), after which this flag will be automatically unset.

If that smart function is not provided for the given object, this flag will be left unchanged.

Note
  just setting this flag will not make the canvas' whole scene dirty, by itself, and evas_render() will have no effect. To force that, use evas_object_smart_changed(), that will also call this function automatically, with `EINA_TRUE` as parameter.

See also
  evas_object_smart_need_recalculate_get()
  evas_object_smart_calculate()
  evas_smart_objects_calculate()

Parameters

  [in] | value | whether one wants to set (`EINA_TRUE`) or to unset (`EINA_FALSE`) the flag.

References evas_obj_smart_need_recalculate_set().

Eina_Bool evas_object_smart_need_recalculate_get | ( | const Evas_Object_Smart * | obj | ) |

Get the value of the flag signalling that a given smart object needs to get recalculated.

Returns
  if flag is set or not.

Note
  this flag will be unset during the rendering phase, when the `calculate()` smart function is called, if one is provided. If it's not provided, then the flag will be left unchanged after the rendering phase.

See also
  evas_object_smart_need_recalculate_set(), for more details

References evas_obj_smart_need_recalculate_get().

void evas_object_smart_data_set | ( | Evas_Object_Smart * | obj,
|  | void * | data
| ) |  |

Store a pointer to user data for a given smart object.

This data is stored independently of the one set by evas_object_data_set(), naturally.

See also
  evas_object_smart_data_get()

Parameters

  [in] | data | A pointer to user data

References evas_obj_smart_data_set().

Evas_Smart* evas_object_smart_smart_get | ( | const Evas_Object_Smart * | obj | ) |

Get the Evas_Smart from which `obj` smart object was created.

Returns
  the Evas_Smart handle or `NULL`, on errors

References evas_obj_smart_get().

Referenced by evas_object_smart_interface_data_get(), and evas_object_smart_interface_get().

Eina_Bool evas_object_smart_callbacks_descriptions_set | ( | Evas_Object_Smart * | obj,
|  | const Evas_Smart_Cb_Description * | descriptions
| ) |  |

Set an smart object instance's smart callbacks descriptions.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on failure.

These descriptions are hints to be used by introspection and are not enforced in any way.

It will not be checked if instance callbacks descriptions have the same name as respective possibly registered in the smart object class. Both are kept in different arrays and users of evas_object_smart_callbacks_descriptions_get() should handle this case as they wish.

Note
  Becase `descriptions` must be `NULL` terminated, and because a `NULL` name makes little sense, too, Evas_Smart_Cb_Description.name must not be `NULL`.
  While instance callbacks descriptions are possible, they are not recommended. Use class callbacks descriptions instead as they make you smart object user's life simpler and will use less memory, as descriptions and arrays will be shared among all instances.

Parameters

  [in] | descriptions | `NULL` terminated array with Evas_Smart_Cb_Description descriptions. Array elements won't be modified at run time, but references to them and their contents will be made, so this array should be kept alive during the whole object's lifetime.

References evas_obj_smart_callbacks_descriptions_set().

void evas_object_smart_callbacks_descriptions_get | ( | const Evas_Object_Smart * | obj,
|  | const Evas_Smart_Cb_Description *** | class_descriptions,
|  | unsigned int * | class_count,
|  | const Evas_Smart_Cb_Description *** | instance_descriptions,
|  | unsigned int * | instance_count
| ) |  |

Retrieve an smart object's know smart callback descriptions (both instance and class ones).

This call searches for registered callback descriptions for both instance and class of the given smart object. These arrays will be sorted by Evas_Smart_Cb_Description.name and also `NULL` terminated, so both class_count and instance_count can be ignored, if the caller wishes so. The terminator `NULL` is not counted in these values.

Note
  If just class descriptions are of interest, try evas_smart_callbacks_descriptions_get() instead.
  Use `NULL` pointers on the descriptions/counters you're not interested in: they'll be ignored by the function.

See also
  evas_smart_callbacks_descriptions_get()

Parameters

  [out] | class_descriptions | Where to store class callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned
  [out] | class_count | Returns how many class callbacks descriptions are known.
  [out] | instance_descriptions | Where to store instance callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned.
  [out] | instance_count | Returns how many instance callbacks descriptions are known.

References evas_obj_smart_callbacks_descriptions_get().

void evas_object_smart_calculate | ( | Evas_Object_Smart * | obj | ) |

Call the calculate() smart function immediately on a given smart object.

This will force immediate calculations (see Evas_Smart_Class) needed for renderization of this object and, besides, unset the flag on it telling it needs recalculation for the next rendering phase.

See also
  evas_object_smart_need_recalculate_set()

References evas_obj_smart_calculate().

void evas_object_smart_changed | ( | Evas_Object_Smart * | obj | ) |

Mark smart object as changed, dirty.

This will flag the given object as needing recalculation, forcefully. As an effect, on the next rendering cycle its calculate() (see Evas_Smart_Class) smart function will be called.

See also
  evas_object_smart_need_recalculate_set().
  evas_object_smart_calculate().

References evas_obj_smart_changed().

void evas_smart_legacy_type_register | ( | const char * | type,
|  | const Eo_Class * | klass
| ) |  |

Registers an object type and its associated class.

LEGACY MECHANISM SUPPORT.

This function is invoked in the class constructor of smart classes. It will add the type and the class into a hash table that will then be used to check the type of an object. This function has been implemented to support legacy mechanism that checks objects types by name. USE IT ONLY FOR LEGACY SUPPORT. Otherwise, it is HIGHLY recommended to use eo_isa.

Parameters

  type | The type (name string) to add.
  klass | The class to associate to the type.

See also
  eo_isa

References eina_hash_set().

Evas_Object* evas_object_smart_add | ( | Evas * | e,
|  | Evas_Smart * | s
| ) |  |

Instantiates a new smart object described by `s`.

Parameters

  e | the canvas on which to add the object
  s | the Evas_Smart describing the smart object

Returns
  a new Evas_Object handle

This is the function one should use when defining the public function adding an instance of the new smart object to a given canvas. It will take care of setting all of its internals to work as they should, if the user set things properly, as seem on the EVAS_SMART_SUBCLASS_NEW, for example.

void evas_object_smart_member_add | ( | Evas_Object * | obj,
|  | Evas_Object * | smart_obj
| ) |  |

Set an Evas object as a member of a given smart object.

Parameters

  obj | The member object
  smart_obj | The smart object

Members will automatically be stacked and layered together with the smart object. The various stacking functions will operate on members relative to the other members instead of the entire canvas, since they now live on an exclusive layer (see evas_object_stack_above(), for more details).

Any `smart_obj` object's specific implementation of the `member_add()` smart function will take place too, naturally.

See also
  evas_object_smart_member_del()
  evas_object_smart_members_get()

References evas_obj_smart_member_add().

void evas_object_smart_member_del | ( | Evas_Object * | obj | ) |

Removes a member object from a given smart object.

Parameters

  obj | the member object

This removes a member object from a smart object, if it was added to any. The object will still be on the canvas, but no longer associated with whichever smart object it was associated with.

See also
  evas_object_smart_member_add() for more details
  evas_object_smart_members_get()

References evas_obj_smart_member_del().

void evas_object_smart_callback_add | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Add (register) a callback function to the smart event specified by `event` on the smart object `obj`.

Parameters

  obj | a smart object
  event | the event's name string
  func | the callback function
  data | user data to be passed to the callback function

Smart callbacks look very similar to Evas callbacks, but are implemented as smart object's custom ones.

This function adds a function callback to an smart object when the event named `event` occurs in it. The function is `func`.

In the event of a memory allocation error during addition of the callback to the object, evas_alloc_error() should be used to determine the nature of the error, if any, and the program should sensibly try and recover.

A smart callback function must have the Evas_Smart_Cb prototype definition. The first parameter (`data`) in this definition will have the same value passed to evas_object_smart_callback_add() as the `data` parameter, at runtime. The second parameter `obj` is a handle to the object on which the event occurred. The third parameter, `event_info`, is a pointer to data which is totally dependent on the smart object's implementation and semantic for the given event.

There is an infrastructure for introspection on smart objects' events (see evas_smart_callbacks_descriptions_get()), but no internal smart objects on Evas implement them yet.

See also
  Smart events and callbacks for more details.
  evas_object_smart_callback_del()

References EVAS_CALLBACK_PRIORITY_DEFAULT, and evas_object_smart_callback_priority_add().

void evas_object_smart_callback_priority_add | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Callback_Priority | priority,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Add (register) a callback function to the smart event specified by `event` on the smart object `obj`.

Except for the priority field, it's exactly the same as evas_object_smart_callback_add

Parameters

  obj | a smart object
  event | the event's name string
  priority | The priority of the callback, lower values called first.
  func | the callback function
  data | user data to be passed to the callback function

See also
  evas_object_smart_callback_add

Since
  1.1

References eina_inlist_append(), and EINA_INLIST_GET.

Referenced by evas_object_smart_callback_add().

void* evas_object_smart_callback_del | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Smart_Cb | func
| ) |  |

Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`.

Parameters

  obj | a smart object
  event | the event's name string
  func | the callback function

Returns
  the data pointer

This function removes the first added smart callback on the object `obj` matching the event name `event` and the registered function pointer `func`. If the removal is successful it will also return the data pointer that was passed to evas_object_smart_callback_add() (that will be the same as the parameter) when the callback(s) was(were) added to the canvas. If not successful `NULL` will be returned.

See also
  evas_object_smart_callback_add() for more details.

References EINA_INLIST_FOREACH, EINA_INLIST_GET, and eina_inlist_remove().

void* evas_object_smart_callback_del_full | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`.

Parameters

  obj | a smart object
  event | the event's name string
  func | the callback function
  data | the data pointer that was passed to the callback

Returns
  the data pointer

This function removes the first added smart callback on the object `obj` matching the event name `event`, the registered function pointer `func` and the callback data pointer `data`. If the removal is successful it will also return the data pointer that was passed to evas_object_smart_callback_add() (that will be the same as the parameter) when the callback(s) was(were) added to the canvas. If not successful `NULL` will be returned. A common use would be to remove an exact match of a callback

See also
  evas_object_smart_callback_add() for more details.

Since
  1.2

Note
  To delete all smart event callbacks which match `type` and `func`, use evas_object_smart_callback_del().

References EINA_INLIST_FOREACH, EINA_INLIST_GET, and eina_inlist_remove().

void evas_object_smart_callback_call | ( | Evas_Object * | obj,
|  | const char * | event,
|  | void * | event_info
| ) |  |

Call a given smart callback on the smart object `obj`.

Parameters

  obj | the smart object
  event | the event's name string
  event_info | pointer to an event specific struct or information to pass to the callback functions registered on this smart event

This should be called internally, from the smart object's own code, when some specific event has occurred and the implementor wants is to pertain to the object's events API (see Smart events and callbacks). The documentation for the smart object should include a list of possible events and what type of `event_info` to expect for each of them. Also, when defining an Evas_Smart_Class, smart object implementors are strongly encouraged to properly set the Evas_Smart_Class::callbacks callbacks description array, so that the users of the smart object can have introspection on its events API at run time.

Referenced by emotion_object_last_position_load(), and emotion_object_last_position_save().

const void* evas_object_smart_interface_get | ( | const Evas_Object * | obj,
|  | const char * | name
| ) |  |

Retrieve an Evas smart object's interface, by name string pointer.

Parameters

  obj | An Evas smart object.
  name | Name string of the desired interface, which must be the same pointer used at the interface's declarion, when creating the smart object obj.

Since
  1.7

Returns
  The interface's handle pointer, if found, `NULL` otherwise.

Examples:
  evas-smart-interface.c.

References evas_object_smart_smart_get(), and _Evas_Smart_Interface::name.

void* evas_object_smart_interface_data_get | ( | const Evas_Object * | obj,
|  | const Evas_Smart_Interface * | iface
| ) |  |

Retrieve an Evas smart object interface's private data.

Parameters

  obj | An Evas smart object.
  iface | The given object's interface handle.

Since
  1.7

Returns
  The object interface's private data blob pointer, if found, `NULL` otherwise.

Examples:
  evas-smart-interface.c.

References evas_object_smart_smart_get().